<cfsilent>
<!---
I'm a simple XML-based charting engine.  The descriptor XML may be
passed either as the body of the tag, or via the 'descriptor' attribute.
See FlexChart.mxml for details of the descriptor XML.

NOTE: This file MUST reside in a web accessible location, along with
the rest of the distribution.  If invoked directly (i.e., not as a
custom tag) the file will simply exit with no output.

This tag doesn't expose some of the more advanced capabilities of
FlexChart.mxml, such as runtime descriptor swapping and URL-based
descriptor fetching, though all but a FlashVars-configured descriptorUrl
are doable via your own means.
--->

<cfif NOT structKeyExists(variables, "thisTag")>
	<cfexit method="exittemplate" />
</cfif>

<cfset __default_swf_path__ = "__default_swf_path__" />

<cfparam name="attributes.width" default="450" />
<cfparam name="attributes.height" default="300" />
<cfparam name="attributes.id" default="chart_#getTickCount()#_#removeChars(rand(), 1, 2)#" />
<cfparam name="attributes.bgcolor" default="##ffffff" />
<cfparam name="attributes.baseUrl" default="" />
<cfparam name="attributes.swfPath" type="string" default="#__default_swf_path__#" />
<cfparam name="attributes.compressDescriptor" type="boolean" default="true" />
<cfparam name="attributes.wmode" default="transparent" />

<cffunction name="flexchart_drawChart" output="true" returntype="void">
	<cfset var relPath = attributes.swfPath />
	<cfsilent>
	<cfif relPath EQ __default_swf_path__>
		<cfset relPath = flexchart_relativePath(
			REReplace(replace(expandPath("."), "\", "/", "all"), "/+$", ""),
			REReplace(replace(getDirectoryFromPath(getCurrentTemplatePath()), "\", "/", "all"), "/+$", "")
		) />
	</cfif>
	<cfif len(relPath) GT 0 AND right(relPath, 1) NEQ "/">
		<cfset relPath = relPath & "/" />
	</cfif>
	<cfif attributes.compressDescriptor>
		<cfset attributes.descriptor = trim(attributes.descriptor) />
		<cfset attributes.descriptor = REReplace(attributes.descriptor, ">[\r\n\t\f ]+<", "><", "all") />
		<cfset attributes.descriptor = REReplace(attributes.descriptor, """[\r\n\t\f ]+", """ ", "all") />
	</cfif>
	</cfsilent>
	<cfoutput>
<cfif request.__flex_chart_count__ EQ 1>
<script src="#relPath#AC_OETags.js" language="javascript"></script>
</cfif>
<script language="JavaScript" type="text/javascript">
<!--
var requiredMajorVersion = parseInt("9");
var requiredMinorVersion = parseInt("0");
var requiredRevision = parseInt("28");
var hasProductInstall = DetectFlashVer(6, 0, 65);
var hasRequestedVersion = DetectFlashVer(requiredMajorVersion, requiredMinorVersion, requiredRevision);
if ( hasProductInstall && !hasRequestedVersion ) {
	var MMPlayerType = (isIE == true) ? "ActiveX" : "PlugIn";
	var MMredirectURL = window.location;
    document.title = document.title.slice(0, 47) + " - Flash Player Installation";
    var MMdoctitle = document.title;

	AC_FL_RunContent(
		"src", "#relPath#playerProductInstall",
		"FlashVars", "MMredirectURL="+MMredirectURL+'&MMplayerType='+MMPlayerType+'&MMdoctitle='+MMdoctitle+"",
		"width", "#attributes.width#",
		"height", "#attributes.height#",
		"align", "middle",
		"id", "#attributes.id#",
		"quality", "high",
		"bgcolor", "#attributes.bgcolor#",
		"name", "#attributes.id#",
		"allowScriptAccess","sameDomain",
		"type", "application/x-shockwave-flash",
		"pluginspage", "http://www.adobe.com/go/getflashplayer"
	);
} else if (hasRequestedVersion) {
	AC_FL_RunContent(
			"src", "#relPath#FlexChart",
			"width", "#attributes.width#",
			"height", "#attributes.height#",
			"align", "middle",
			"id", "#attributes.id#",
			"quality", "high",
			"bgcolor", "#attributes.bgcolor#",
			"name", "#attributes.id#",
			"allowScriptAccess","sameDomain",
			"flashvars","descriptor=#jsStringFormat(urlEncodedFormat(attributes.descriptor))#<cfif len(trim(attributes.baseUrl)) GT 0>&baseUrl=#jsStringFormat(urlEncodedFormat(attributes.baseUrl))#</cfif>",
			"type", "application/x-shockwave-flash",
			"wmode", "#attributes.wmode#",
			"pluginspage", "http://www.adobe.com/go/getflashplayer"
	);
  } else {
    var alternateContent = 'Alternate HTML content should be placed here. '
  	+ 'This content requires the Adobe Flash Player. '
   	+ '<a href=http://www.adobe.com/go/getflash/>Get Flash</a>';
    document.write(alternateContent);
  }
// -->
</script>
	</cfoutput>
</cffunction>

<cffunction name="flexchart_relativePath" returntype="string" access="public" output="false"
			hint="I compute the relative path from one file system location to another.">
	<cfargument name="from" type="string" required="true"
				hint="I am the full pathname from which the relative path should be computed." />
	<cfargument name="to" type="string" required="true"
				hint="I am the full pathname to which the relative path should be computed." />

	<cfset var relative = "" />
	<cfset var fromFirst = listFirst(arguments.from,"/") />
	<cfset var fromRest = arguments.from />
	<cfset var toFirst = listFirst(arguments.to,"/") />
	<cfset var toRest = arguments.to />
	<cfset var needSlash = false />

	<!--- trap special case first --->
	<cfif arguments.from is arguments.to>
		<cfreturn "" />
	</cfif>

	<!--- walk down the common part of the paths --->
	<cfloop condition="fromFirst is toFirst">
		<cfset needSlash = true />
		<cfset fromRest = listRest(fromRest,"/") />
		<cfset toRest = listRest(toRest,"/") />
		<cfset fromFirst = listFirst(fromRest,"/") />
		<cfset toFirst = listFirst(toRest,"/") />
	</cfloop>
	<!--- at this point the paths differ --->
	<cfif not needSlash>
		<!--- the paths differed from the top so we need to strip the leading / --->
		<cfset toRest = right(toRest,len(toRest)-1) />
	</cfif>
	<cfset relative = repeatString("../",listLen(fromRest,"/")) & toRest />
	<!---
		ensure the trailing / is present - strictly speaking this is a bug fix for Railo
		but it's probably a good practice anyway
	--->
	<cfif right(relative,1) is not "/">
		<cfset relative = relative & "/" />
	</cfif>

	<cfreturn relative />

</cffunction>
</cfsilent>
<cfif thisTag.executionMode EQ "start">
	<cfparam name="request.__flex_chart_count__" default="0" />
	<cfset request.__flex_chart_count__ = request.__flex_chart_count__ + 1 />
	<cfset injectedPrepChartDate = false />
	<cfif NOT thisTag.hasEndTag>
		<cfif NOT structKeyExists(attributes, "descriptor")>
			<cfthrow type="NoDataException"
				message="If you don't provide a descriptor in the tag body, you must provide it via the 'descriptor' attribute." />
		</cfif>
		<cfset flexchart_drawChart() />
	</cfif>
	<cfif NOT structKeyExists(caller, "prepChartDate")>
		<cfif NOT structKeyExists(variables, "prepChartDate")>
			<cfinclude template="udf_prepchartdate.cfm" />
		</cfif>
		<cfset caller["prepChartDate"] = prepChartDate />
		<cfset injectedPrepChartDate = true />
	</cfif>
<cfelse> <!--- end --->
	<cfif len(trim(thisTag.generatedContent)) GT 0>
		<cfset attributes.descriptor = thisTag.generatedContent />
	</cfif>
	<cfset thisTag.generatedContent = "" />
	<cfset flexchart_drawChart() />
	<cfif injectedPrepChartDate>
		<cfset structDelete(caller, "prepChartDate") />
	</cfif>
</cfif>