<cfimport prefix="c" taglib="." />

<cfparam name="url.type" default="numeric" />
<cfsetting showdebugoutput="false" />
<cfoutput>
<cfswitch expression="#url.type#">

	<cfcase value="category">
		<chart type="bar">
			<xaxis type="linear" />
			<yaxis type="category" />
			<data>
				<set type="bar" label="Set ##1">
					<!--
					the x and y attributes of the points are reversed so
					it's still category-then-point, even though the axes
					are reversed for the bar chart.
					-->
					<cfloop from="2" to="3" index="i">
						<series type="bar" label="Series ###i - 1#">
							<cfloop from="7" to="1" index="j" step="-1">
								<point y="#dayOfWeekAsString(j)#" x="#randRange(1, i * j)#" />
							</cfloop>
						</series>
					</cfloop>
				</set>
			</data>
		</chart>
	</cfcase>

	<cfcase value="datetime">
		<chart type="cartesian" legendPlacement="top">
			<xaxis type="datetime" />
			<yaxis type="linear" />
			<data>
				<series type="area" label="Series ##1">
					<cfloop from="1" to="10" index="j">
						<c:prepdate date="#dateAdd('d', -20 + j, now())#" result="d" />
						<point x="#d#" y="#randRange(1, j)#" />
					</cfloop>
				</series>
				<cfloop from="2" to="3" index="i">
					<series type="line" label="Series ###i#">
						<cfloop from="1" to="10" index="j">
							<c:prepdate date="#dateAdd('d', -20 + j, now())#" result="d" />
							<point x="#d#" y="#randRange(1, i * j)#" />
						</cfloop>
					</series>
				</cfloop>
			</data>
		</chart>
	</cfcase>

	<cfcase value="empty"><chart></chart></cfcase>

	<cfcase value="gradients">
		<chart>
			<data>
				<cfset types = listToArray("area,bar,column,line") />
				<cfset markers = listToArray("circle,cross,diamond,triangle") />
				<cfloop from="1" to="#arrayLen(types)#" index="i">
					<series type="#types[i]#"
							label="#types[i]# series"
							markerType="#markers[randRange(1, 4)]#"
							strokeWeight="1"
							strokeColor="0xff0000"
							fillColor="[0x0000ff,0x00ff00]">
							<cfloop from="1" to="8" index="j">
								<point x="#j#" y="#randRange(1, i + j)#" />
							</cfloop>
					</series>
				</cfloop>
			</data>
		</chart>
	</cfcase>

	<cfcase value="grouped">
		<cfset quarters = "Q2'98,Q3'98,Q4'98,Q1'99,Q2'99,Q3'99" />
		<chart type="column"
			legendPlacement="right"
			legendStyle="grouped">
			<xaxis type="category" />
			<yaxis type="linear" />
			<data>
				<set type="column" grouping="clustered">
					<set grouping="stacked"label="Series 1" color="0x009900">
						<series label="Ye Bad Stuff" fillColor="0xff0000">
							<cfloop list="#quarters#" index="q">
								<point x="#q#" y="#randRange(25, 50)#" />
							</cfloop>
						</series>
						<series label="Ye Unfortunate Stuff" fillColor="0x003300">
							<cfloop list="#quarters#" index="q">
								<point x="#q#" y="#randRange(25, 1200)#" />
							</cfloop>
						</series>
						<series label="Ye Continuing Stuff" fillColor="0x006600">
							<cfloop list="#quarters#" index="q">
								<point x="#q#" y="#randRange(25, 40)#" />
							</cfloop>
						</series>
						<series label="Ye Good Stuff" fillColor="0x009900">
							<cfloop list="#quarters#" index="q">
								<point x="#q#" y="#randRange(18, 100)#" />
							</cfloop>
						</series>
					</set>
					<set grouping="stacked" label="Series 2, eh?" color="0x0000ff">
						<series label="Ye Bad Stuff" fillColor="0xff0000">
							<cfloop list="#quarters#" index="q">
								<point x="#q#" y="#randRange(80, 325)#" />
							</cfloop>
						</series>
						<series label="Ye Unfortunate Stuff" fillColor="0x000099">
							<cfloop list="#quarters#" index="q">
								<point x="#q#" y="#randRange(2000, 3000)#" />
							</cfloop>
						</series>
						<series label="Ye Continuing Stuff" fillColor="0x0000cc">
							<cfloop list="#quarters#" index="q">
								<point x="#q#" y="#randRange(25, 40)#" />
							</cfloop>
						</series>
						<series label="Ye Good Stuff" fillColor="0x0000ff">
							<cfloop list="#quarters#" index="q">
								<point x="#q#" y="#randRange(225, 600)#" />
							</cfloop>
						</series>
					</set>
				</set>
			</data>
		</chart>
	</cfcase>

	<cfcase value="grouped_single">
		<chart legendPlacement="right" type="cartesian" legendStyle="grouped">
			<xaxis type="category"></xaxis>
			<yaxis id="y1" label="Visits" maximum="14000" type="linear"></yaxis>
			<yaxis id="y2" label="Conversion %" placement="right" type="linear"></yaxis>
			<data>
				<set grouping="clustered" type="column" yaxis="y1">
					<set grouping="stacked" label="Series 1">
						<series label="Customer Download">
							<point x="Mar 09" y="106"></point>
							<point x="Apr 09" y="92"></point>
							<point x="May 09" y="91"></point>
							<point x="Jun 09" y="71"></point>
							<point x="Jul 09" y="68"></point>
							<point x="Aug 09" y="63"></point>
							<point x="Sep 09" y="123"></point>
							<point x="Oct 09" y="22"></point>
						</series>
						<series label="Demo">
							<point x="Mar 09" y="1837"></point>
							<point x="Apr 09" y="1832"></point>
							<point x="May 09" y="1129"></point>
							<point x="Jun 09" y="992"></point>
							<point x="Jul 09" y="943"></point>
							<point x="Aug 09" y="726"></point>
							<point x="Sep 09" y="1041"></point>
							<point x="Oct 09" y="189"></point>
						</series>
						<series label="Info Request">
							<point x="Mar 09" y="79"></point>
							<point x="Apr 09" y="98"></point>
							<point x="May 09" y="92"></point>
							<point x="Jun 09" y="95"></point>
							<point x="Jul 09" y="97"></point>
							<point x="Aug 09" y="78"></point>
							<point x="Sep 09" y="101"></point>
							<point x="Oct 09" y="21"></point>
						</series>
					</set>
					<set grouping="stacked" label="Series 2">
						<series label="No Offer">
							<point x="Mar 09" y="6240"></point>
							<point x="Apr 09" y="6477"></point>
							<point x="May 09" y="5949"></point>
							<point x="Jun 09" y="5896"></point>
							<point x="Jul 09" y="6944"></point>
							<point x="Aug 09" y="4116"></point>
							<point x="Sep 09" y="5026"></point>
							<point x="Oct 09" y="941"></point>
						</series>
						<series label="Online Seminar">
							<point x="Mar 09" y="24"></point>
							<point x="Apr 09" y="187"></point>
							<point x="May 09" y="76"></point>
							<point x="Jun 09" y="330"></point>
							<point x="Jul 09" y="49"></point>
							<point x="Aug 09" y="268"></point>
							<point x="Sep 09" y="319"></point>
							<point x="Oct 09" y="97"></point>
						</series>
						<series label="Promo">
							<point x="Mar 09" y="79"></point>
							<point x="Apr 09" y="74"></point>
							<point x="May 09" y="49"></point>
							<point x="Jun 09" y="21"></point>
							<point x="Jul 09" y="21"></point>
							<point x="Aug 09" y="31"></point>
							<point x="Sep 09" y="16"></point>
							<point x="Oct 09" y="2"></point>
						</series>
						<series label="Seminar">
							<point x="Mar 09" y="121"></point>
							<point x="Apr 09" y="160"></point>
							<point x="May 09" y="406"></point>
							<point x="Jun 09" y="270"></point>
							<point x="Jul 09" y="89"></point>
							<point x="Aug 09" y="509"></point>
							<point x="Sep 09" y="216"></point>
							<point x="Oct 09" y="169"></point>
						</series>
					</set>
					<set grouping="stacked" label="Series 3">
						<series label="Software Eval">
							<point x="Mar 09" y="866"></point>
							<point x="Apr 09" y="829"></point>
							<point x="May 09" y="770"></point>
							<point x="Jun 09" y="673"></point>
							<point x="Jul 09" y="582"></point>
							<point x="Aug 09" y="453"></point>
							<point x="Sep 09" y="533"></point>
							<point x="Oct 09" y="104"></point>
						</series>
						<series label="Tech Pub">
							<point x="Mar 09" y="2328"></point>
							<point x="Apr 09" y="1441"></point>
							<point x="May 09" y="1014"></point>
							<point x="Jun 09" y="1021"></point>
							<point x="Jul 09" y="1898"></point>
							<point x="Aug 09" y="1478"></point>
							<point x="Sep 09" y="1357"></point>
							<point x="Oct 09" y="334"></point>
						</series>
						<series label="Workshop">
							<point x="Mar 09" y="199"></point>
							<point x="Apr 09" y="223"></point>
							<point x="May 09" y="237"></point>
							<point x="Jun 09" y="98"></point>
							<point x="Jul 09" y="27"></point>
							<point x="Aug 09" y="67"></point>
							<point x="Sep 09" y="81"></point>
							<point x="Oct 09" y="8"></point>
						</series>
					</set>
				</set>
				<series label="conversion % 1" markerType="diamond" type="line" yaxis="y2">
					<point x="Mar 09" y="27.66"></point>
					<point x="Apr 09" y="18.65"></point>
					<point x="May 09" y="19.33"></point>
					<point x="Jun 09" y="20.76"></point>
					<point x="Jul 09" y="24.13"></point>
					<point x="Aug 09" y="11.23"></point>
					<point x="Sep 09" y="40.75"></point>
					<point x="Oct 09" y="18.86"></point>
				</series>
				<series label="conversion % 2" markerType="circle" type="line" yaxis="y2">
					<point x="Mar 09" y="7.66"></point>
					<point x="Apr 09" y="8.65"></point>
					<point x="May 09" y="9.33"></point>
					<point x="Jun 09" y="0.76"></point>
					<point x="Jul 09" y="4.13"></point>
					<point x="Aug 09" y="1.23"></point>
					<point x="Sep 09" y="0.75"></point>
					<point x="Oct 09" y="8.86"></point>
				</series>
				<series label="conversion % 3" markerType="cross" type="line" yaxis="y2">
					<point x="Mar 09" y="2.66"></point>
					<point x="Apr 09" y="1.65"></point>
					<point x="May 09" y="1.33"></point>
					<point x="Jun 09" y="2.76"></point>
					<point x="Jul 09" y="2.13"></point>
					<point x="Aug 09" y="1.23"></point>
					<point x="Sep 09" y="4.75"></point>
					<point x="Oct 09" y="1.86"></point>
				</series>
			</data>
		</chart>
	</cfcase>

	<cfcase value="multiaxis">
		<chart type="line">
			<xaxis type="category" />
			<yaxis id="axis1"
				type="linear"
				label="first axis" />
			<yaxis id="axis2"
				type="linear"
				label="second axis"
				placement="right" />
			<data>
				<series type="line"
					label="first series"
					yaxis="axis1">
					<cfloop from="1" to="8" index="i">
						<point x="#i#" y="#randRange(int(i / 2), i)#" />
					</cfloop>
				</series>
				<series type="line"
					label="my second series"
					yaxis="axis2">
					<cfloop from="1" to="8" index="i">
						<point x="#i#" y="#randRange(int(i / 2), i) * 100#" />
					</cfloop>
				</series>
			</data>
		</chart>
	</cfcase>

	<cfcase value="pie">
		<chart type="pie" legendPlacement="right">
			<data>
				<series type="pie" label="Series ##1">
					<cfloop from="1" to="7" index="i">
						<point x="#dayOfWeekAsString(i)#" y="#randRange(1, i)#" />
					</cfloop>
				</series>
			</data>
		</chart>
	</cfcase>

	<cfcase value="pie_filled">
		<chart type="pie" legendPlacement="right">
			<data>
				<series type="pie" label="Series ##1">
					<cfloop from="1" to="7" index="i">
						<point x="#dayOfWeekAsString(i)#" y="#randRange(1, i)#" fillColor="[0x#repeatString(formatBaseN(i, 16), 6)#,0x#repeatString(formatBaseN(i + 8, 16), 6)#]" />
					</cfloop>
				</series>
			</data>
		</chart>
	</cfcase>

	<cfdefaultcase><!--- numeric --->
		<chart type="cartesian" legendPlacement="top" click="dataPointClicked"
				dataTipFunction="formatDataTip">
			<xaxis type="linear"
				baseAtZero="false"
				label="my x axis"
				placement="top" />
			<yaxis type="linear"
				label="my y axis"
				placement="right" />
			<data>
				<set type="column" label="Set ##1" grouping="clustered">
					<cfloop from="1" to="2" index="i">
						<series label="Series ###i#" fillColor="0xff0000" strokeColor="0x00ff00">
							<cfloop from="3" to="10" index="j">
								<point x="#j#" y="#randRange(1, i * j)#" />
							</cfloop>
						</series>
					</cfloop>
				</set>
				<cfloop from="3" to="4" index="i">
					<series type="line" label="Series ###i#" strokeWeight="#(i - 3) * 4 + 1#" strokeColor="0x0000ff">
						<cfloop from="3" to="10" index="j">
							<point x="#j#" y="#randRange(1, i * j)#" />
						</cfloop>
					</series>
				</cfloop>
			</data>
		</chart>
	</cfdefaultcase>

</cfswitch>
</cfoutput>
<cfif expandPath(cgi.script_name) EQ getCurrentTemplatePath()>
	<cfcontent type="text/xml" reset="false" />
</cfif>