<cfimport prefix="c" taglib="." />

<cfparam name="url.name" default="silly" />
<cfoutput>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
         "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>FlexChart Demo App</title>
<script type="text/javascript" src="prototype.js"></script>
<script type="text/javascript">
/**
 * get a descriptor from the server based on the currently selected type
 * and load it into both the chart and the editor.  The chart can do the
 * request all on it's own, but since we need it for the editor as well,
 * we'll use Javascript.
 */
function repopulate() {
	new Ajax.Request("descriptor.cfm", {
		method: "get",
		parameters: {
			type: $F("typeselect"),
			r: Math.random()
		},
		onSuccess: function(t) {
			$("editor").value = t.responseText.replace(/\t/g, "  ").replace(/[\r\n][ \t\r\n]*[\r\n]/g, "\n");
			injectFromEditor();
		}
	});
}
/**
 * Load the editor's contents into the chart.
 */
function injectFromEditor() {
	$("chart").setDescriptor($F("editor"));
}
/**
 * Pulls a PNG snapshot of the chart (Base64 encoded) and opens it in
 * a new window for viewing.
 */
function exportImage() {
	$("exportData").value = $("chart").captureBase64Image($("includeLegend").checked);
	$("exportForm").submit();
}
/**
 * Called by the chart when the user clicks a data point
 */
function dataPointClicked(chartid, seriesLabel, x, y) {
	alert("Point (" + x + ", " + y +") of series " + seriesLabel + " was clicked");
}
/**
 * Called by the chart to generate the text of a data tip for a data point
 */
function formatDataTip(hd) {
	return "<b>" + hd.seriesLabel + "</b>\n"
		+ "[" + hd.xAxisValue + ", " + hd.yAxisValue + "]";
}
// do the initial setup
Event.observe(window, "load", function() {
	repopulate();
	$("editor").style.width = (document.viewport.getWidth() - $("chart").getWidth() - 40) + "px";
})
</script>
</head>
<body>
<h1>FlexChart</h1>
<p>This is the demo site for a simple charting engine built in Flex (for more
details, <a href="http://www.barneyb.com/barneyblog/?s=flexchart">check my blog</a>).
The engine is a Flex app that accepts an XML
descriptor file for what to render and how.  You can change the type of chart
with the dropdown.  You can also create your own descriptor in the editor and load
it into the chart client-side.
</p>
<table border="0"><tr>
<td valign="top">
	<c:FlexChart id="chart"
		width="640"
		height="400"
		compressDescriptor="false">
		<chart />
	</c:FlexChart>
</td>
<td valign="bottom">
	Descriptor Editor<br />
	<textarea id="editor" style="width:400px;height:350px;"></textarea><br />
	<select id="typeselect" onchange="repopulate();">
		<option value="numeric">Numeric Line/Column</option>
		<option value="datetime">DateTime Area/Line</option>
		<option value="category">Category Bar</option>
		<option value="multiaxis">Multi-Axis</option>
		<option value="grouped">Grouped Series</option>
		<option value="grouped_single">Grouped / Single</option>
		<option value="gradients">Gradients</option>
		<option value="pie">Pie</option>
		<option value="pie_filled">Pie (filled)</option>
		<option value="empty">Empty</option>
	</select>
	<button onclick="repopulate();">Reset Chart</button>
	<button onclick="injectFromEditor();">Update Chart</button>
	<div style="text-align:right;">
		<button onclick="exportImage();">PNG Export</button>
		<input type="checkbox" id="includeLegend" checked="checked" />
		<label for="includeLegend">Include Legend</label>
	</div>
</td>
</tr></table>

<p>The source is available at
<a href="https://ssl.barneyb.com/svn/barneyb/flexchart/trunk/">https://ssl.barneyb.com/svn/barneyb/flexchart/trunk/</a>
as a FlexBuilder 3 project.  You can also run the
'<a href="https://ssl.barneyb.com/svn/barneyb/flexchart/trunk/dist/">dist</a>'
subfolder as a precompiled binary instance (drop it and go, with no
FlexBuilder or server requirement).
</p>

<p>There is inline documentation throughout the sample app, FlexChart.cfm
(the wrapper tag) and FlexChart.mxml (the rendering engine).  However, if
you want to get the most of the engine, you're going to want to read some
source.
</p>
<form id="exportForm" method="post" action="export.cfm" target="_blank">
	<input type="hidden" id="exportData" name="data" />
</form>
</body>
</html>
</cfoutput>
